controllers/EmocionesController.php
<?php

namespace app\controllers;

use app\models\Emociones;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EmocionesController implements the CRUD actions for Emociones model.
 */
class EmocionesController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Emociones models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Emociones::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'codemo' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Emociones model.
     * @param int $codemo Codemo
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($codemo)
    {
        return $this->render('view', [
            'model' => $this->findModel($codemo),
        ]);
    }

    /**
     * Creates a new Emociones model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Emociones();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'codemo' => $model->codemo]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Emociones model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $codemo Codemo
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($codemo)
    {
        $model = $this->findModel($codemo);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'codemo' => $model->codemo]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Emociones model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $codemo Codemo
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($codemo)
    {
        $this->findModel($codemo)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Emociones model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $codemo Codemo
     * @return Emociones the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($codemo)
    {
        if (($model = Emociones::findOne(['codemo' => $codemo])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/EntradasController.php
<?php

namespace app\controllers;

use app\models\Entradas;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EntradasController implements the CRUD actions for Entradas model.
 */
class EntradasController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Entradas models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Entradas::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'identrada' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Entradas model.
     * @param int $identrada Identrada
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($identrada)
    {
        return $this->render('view', [
            'model' => $this->findModel($identrada),
        ]);
    }

    /**
     * Creates a new Entradas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Entradas();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'identrada' => $model->identrada]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Entradas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $identrada Identrada
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($identrada)
    {
        $model = $this->findModel($identrada);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'identrada' => $model->identrada]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Entradas model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $identrada Identrada
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($identrada)
    {
        $this->findModel($identrada)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Entradas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $identrada Identrada
     * @return Entradas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($identrada)
    {
        if (($model = Entradas::findOne(['identrada' => $identrada])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    
    
    
    
    
    
}

controllers/SensacionesController.php
<?php

namespace app\controllers;

use app\models\Sensaciones;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * SensacionesController implements the CRUD actions for Sensaciones model.
 */
class SensacionesController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Sensaciones models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Sensaciones::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'codsensa' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Sensaciones model.
     * @param int $codsensa Codsensa
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($codsensa)
    {
        return $this->render('view', [
            'model' => $this->findModel($codsensa),
        ]);
    }

    /**
     * Creates a new Sensaciones model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Sensaciones();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'codsensa' => $model->codsensa]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Sensaciones model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $codsensa Codsensa
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($codsensa)
    {
        $model = $this->findModel($codsensa);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'codsensa' => $model->codsensa]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Sensaciones model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $codsensa Codsensa
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($codsensa)
    {
        $this->findModel($codsensa)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Sensaciones model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $codsensa Codsensa
     * @return Sensaciones the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($codsensa)
    {
        if (($model = Sensaciones::findOne(['codsensa' => $codsensa])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Entradas;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
 public function actionIndex()
{
    try {
        //obtengo las entradas de diario más recientes
        $entradas = \app\models\Entradas::find()->orderBy(['fechaentrada' => SORT_DESC])->limit(6)->all();
    } catch (\Exception $e) {
        Yii::error('Error al recuperar las entradas de diario: ' . $e->getMessage());
        $entradas = [];
    }

    //llamo a la acción para contar las entradas positivas y negativas
    $countResult = $this->actionGraficoEntradas();

    return $this->render('index', [   //renderizo en el index 
        'entradas' => $entradas,
        'positivas' => $countResult['positivas'],
        'negativas' => $countResult['negativas'],
    ]);
}

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
   /*mi primera explotacion de datos con los datos detallados de las ultimas 6 entradas del diario*/
public function actionView($id)
{
    // Buscar la entrada por su ID
    $entrada = Entradas::findOne($id);

    // Verificar si la entrada existe
    if (!$entrada) {
        throw new \yii\web\NotFoundHttpException("La entrada con el ID $id no existe.");
    }

    //Cargar los pensamientos asociados a esta entrada
    $pensamientos = $entrada->getCodpens()->all();
    //cargar las emociones asociadas a esta entrada
    $emociones = $entrada->getCodemos()->all();

    $sensaciones = $entrada->getCodsensas()->all();

    return $this->render('vista_detalles', [
    'entrada' => $entrada,
    'pensamientos' => $pensamientos,
    'sensaciones' => $sensaciones,
    'emociones' => $emociones, 
]);

}

/*grafico*/


public function actionGraficoEntradas()
{
    try {
        // Obtener las entradas de diario más recientes
        $entradas = \app\models\Entradas::find()->orderBy(['fechaentrada' => SORT_DESC])->limit(6)->all();

        //cont para las entradas positivas y negativas
        $positivas = 0;
        $negativas = 0;
        //contar la cantidad de entradas positivas y negativas
        foreach ($entradas as $entrada) {
            $pensamientos = $entrada->getCodpens()->all();
            foreach ($pensamientos as $pensamiento) {
                if ($pensamiento->positivo == 1) {
                    $positivas++;
                } else {
                    $negativas++;
                }
            }
        }
    } catch (\Exception $e) {
        Yii::error('Error al contar las entradas de diario: ' . $e->getMessage());
        $positivas = 0;
        $negativas = 0;
    }

    //retorno un arreglo asociativo con los conteos de entradas positivas y negativas 
    return [
        'positivas' => $positivas,
        'negativas' => $negativas,
    ];
}


public function actionInformacion(){
    
     return $this->render('informacion');
    
}






    
}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;
use yii\helpers\Url;
use rmrevin\yii\fontawesome\FA; //para los logos de las redes socuales

rmrevin\yii\fontawesome\AssetBundle::register($this);
AppAsset::register($this);


?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    
    <!-- nombres -->
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="author" content="Marta Tirador Gutiérrez">
    <meta name="description" content="Aplicación para la gestión de emociones">
    <meta name="keywords" content="HTML, CSS, JavaScript, React">

    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title>Ikigai | Transforma tu vida</title>
    <?php $this->head() ?>
    
    
         <!-- Favicon -->
    <link rel="shortcut icon" href="<?= Url::to('@web/logo.ico') ?>" />
    <link rel="icon" type="image/x-icon" href="<?= Url::to('@web/logo.ico') ?>"/>


    
    
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>
<header>
    <?php
    NavBar::begin([
        'brandLabel' => '<div class="d-flex align-items-center">' . 
                        Html::img('@web/images/morado.png', ['alt'=>Yii::$app->name]) .
                        
                        '</div>',
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
    'options' => ['class' => 'navbar-nav mr-auto custom-margin-left'], // Alineación a la izquierda
    'items' => [
       // ['label' => 'INICIO', 'url' => Yii::$app->homeUrl], //Inicio lleva a la home
        ['label' => '¿QUÉ ES IKIGAI?', 'url' => ['/site/informacion']],
        ['label' => 'OBJETIVOS', 'url' => ['/objetivos/mostrarobjetivos']], 
        ['label' => 'DIARIO', 'url' => ['/diario/crearentrada']], 
        
       
        [
            'label' => 'CRUDs',
            'items' => [
                ['label' => 'Entradas', 'url' => ['/entradas/index']],
                ['label' => 'Pensamientos', 'url' => ['/pensamientos/index']],
                ['label' => 'Emociones', 'url' => ['/emociones/index']],
                ['label' => 'Sensaciones', 'url' => ['/sensaciones/index']],
                ['label' => 'Objetivos', 'url' => ['/objetivos/index']],
                ['label' => 'Registro de Pensamientos', 'url' => ['/registropensamientos/index']],
                ['label' => 'Registro de Emociones', 'url' => ['/registroemociones/index']],
                ['label' => 'Registro de Sensaciones', 'url' => ['/registrosensaciones/index']],
                ['label' => 'Tipos de emociones', 'url' => ['/tiposemociones/index']],
            ],
        ],
        
    ],
]);

    NavBar::end();
    ?>
</header>


<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>
    
<footer class="footer mt-auto py-3 text-muted">
        <div class="container">
            <p class="float-left">&copy;Ikigai_MTG_<?= date('Y') ?></p> 
            <div class="social-icons" style="display: flex; justify-content: flex-end;">
                <?= Html::a(FA::icon('facebook')->size(FA::SIZE_2X), 'https://www.facebook.com', ['class' => 'profile-link']) ?>
                <?= Html::a(FA::icon('instagram')->size(FA::SIZE_2X), 'https://www.instagram.com', ['class' => 'profile-link']) ?>
                <?= Html::a(FA::icon('github')->size(FA::SIZE_2X), 'https://github.com/mtirador', ['class' => 'profile-link']) ?>
            </div>
        </div>
 </footer>


<?php $this->endBody() ?>
    
    <script src="<?= Url::to('@web/js/respuesta.js')?>"></script> <!-- Si o no (Cruds) -->
</body>
</html>
<?php $this->endPage() ?>